%dw 2.0
output application/json

import * from dw::Runtime
import * from dw::core::Strings
import dw::core::Binaries

fun decodeInputs(inputs) =
  inputs mapObject ((value, key, index) ->
      (key): value  update {
              case content at .value -> if(value.kind == "binary") Binaries::fromBase64(content) else content as Binary {encoding: "UTF-8"}
              case encoding at .encoding! if(value.kind == "text") -> "UTF-8"
      })

---
{
  a: run(
  in0.main,
  in0.fs,
  decodeInputs(in0.inputs), {},
  {timeOut: 5000 , securityManager: (grant, args) -> false, maxStackSize: 10}
  ) then {
      logs: $.logs
                map ((item, index) -> item.message substringBefore "Reason" then trim($)),
      success: $.success,
      kind: $.kind,
      message: $.message
  }
}


